using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using System.Threading;
using System.Data.SqlClient;

namespace Masterdata_Importer
{
    public partial class Masterdata : Form 
    {
        public ProgressBar progressBar = new ProgressBar();

        public string msSqlServerString = "";

        public string createTable;

        DataTable dataTable = new DataTable();

        public Masterdata()
        {
            InitializeComponent();
        }

        private void linkLabel1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txtMasterdataPfad.Text=openFileDialog1.FileName;
            }
        }

        public void prepareSQLServer(object status)
        {
            dataTable.Clear();
            //dataTable.Columns.Add("id");

            createTable+=" CREATE TABLE [REPLACE]( ";
	        //createTable+=" [id] [int] IDENTITY(1,1) NOT NULL, ";

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataTable.Clear();
            dataTable = new DataTable();
            
            if (!File.Exists(txtMasterdataPfad.Text))
            {
                MessageBox.Show("Die Datei existiert nicht! Bitte Datei whlen!","Wots lous?");
            }
            else
            {
                StreamReader sr = new StreamReader(txtMasterdataPfad.Text);
                string inputLine = "";

                String[] values = null;
                int i = 0;
                ArrayList pipePositionen = new ArrayList();

                while ((inputLine = sr.ReadLine()) != null)
                {
                    i++;

                    if (i == anzahlBisAbbruch.Value) break;

                    if (i == 4)
                    {
                        values = inputLine.Split(new Char[] { '|' });

                        for (int j = 2; j < values.Length-1; j++)
                        {
                            if (!cbDatenZeigen.Checked) dataGridView1.Columns.Add(values[j].Trim(), values[j].Trim());
                            pipePositionen.Add(inputLine.IndexOf(values[j]));
                            dataTable.Columns.Add(values[j].Trim());
                            createTable += " ["+values[j].Trim()+"] [varchar](255) NULL"+( (j==values.Length-2)?"":"," )+" ";
                        }

                        continue;
                    }

                    if (i > 4)
                    {
                        values = inputLine.Split(new Char[] { '|' });

                        if (values.Length < pipePositionen.Count) continue;

                        ArrayList objects = new ArrayList();

                        for (int t = 0; t < pipePositionen.Count; t++)
                        {
                            int laenge = 0;
                            if (pipePositionen.Count - 1 == t)
                            {
                                laenge = inputLine.Length - Int32.Parse(pipePositionen[t].ToString());
                            }
                            else
                            {
                                laenge = Int32.Parse(pipePositionen[t + 1].ToString()) - Int32.Parse(pipePositionen[t].ToString());
                            }

                            string aktuell = "";
                            try
                            {
                                aktuell = inputLine.Substring(Int32.Parse(pipePositionen[t].ToString()), laenge - 1);
                            }
                            catch (ArgumentOutOfRangeException e)
                            {
                                aktuell = "Datensatz durch Importer nicht lesbar";
                            }

                            objects.Add(aktuell.Trim());
                        }

                        if (!cbDatenZeigen.Checked) dataGridView1.Rows.Add(objects.ToArray());
                        int anzahl = dataTable.Columns.Count;
                        dataTable.Rows.Add(objects.ToArray());
                    }
                }

                sr.Close();
            }

            createTable += ") ON [PRIMARY] ";
            txtCreateTable.Text = createTable.Replace("[REPLACE]", txtImportTable.Text);
            tabControl1.SelectedIndex = 1;
        }

        private void testDBAndCreateTable()
        {
            if (testDB())
            {
                this.executeStatement("DROP TABLE [" + txtImportTable.Text + "]");
                this.executeStatement(txtCreateTable.Text);
                tabControl1.SelectedIndex = 2;
            }
            else
            {
                MessageBox.Show("Es kann keine Datenbankverbindung aufgebaut werden.", "Fehler!");
            }
        }

        private void bulkInsert()
        {
            this.WriteToDatabase();
        }

        private void btnWeiter_Click(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 3)
            {
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = false;
            }
            else if (tabControl1.SelectedIndex == 2)
            {
                tabControl1.SelectedIndex = 4;
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = true;
                bulkInsert();
            }
            else if (tabControl1.SelectedIndex == 1)
            {
                tabControl1.SelectedIndex = 4;
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = true;
                testDBAndCreateTable();
            } 
            else if (tabControl1.SelectedIndex == 0)
            {
                tabControl1.SelectedIndex = 4;
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = true;
                prepareSQLServer(null);
            }
        }

        private void txtImportTable_TextChanged(object sender, EventArgs e)
        {
            txtCreateTable.Text = createTable.Replace("[REPLACE]", txtImportTable.Text);
        }

        private void Masterdata_Load(object sender, EventArgs e)
        {
            msSqlServerString = "Data Source="+txtHostname.Text+";Initial Catalog="+txtDatenbank.Text+";User ID="+txtUsername.Text+";Password="+txtPasswort.Text;
        }

        private void txtHostname_TextChanged(object sender, EventArgs e)
        {
            msSqlServerString = "Data Source=" + txtHostname.Text + ";Initial Catalog=" + txtDatenbank.Text + ";User ID=" + txtUsername.Text + ";Password=" + txtPasswort.Text;
        }

        private void txtUsername_TextChanged(object sender, EventArgs e)
        {
            msSqlServerString = "Data Source=" + txtHostname.Text + ";Initial Catalog=" + txtDatenbank.Text + ";User ID=" + txtUsername.Text + ";Password=" + txtPasswort.Text;
        }

        private void txtPasswort_TextChanged(object sender, EventArgs e)
        {
            msSqlServerString = "Data Source=" + txtHostname.Text + ";Initial Catalog=" + txtDatenbank.Text + ";User ID=" + txtUsername.Text + ";Password=" + txtPasswort.Text;
        }

        private void txtDatenbank_TextChanged(object sender, EventArgs e)
        {
            msSqlServerString = "Data Source=" + txtHostname.Text + ";Initial Catalog=" + txtDatenbank.Text + ";User ID=" + txtUsername.Text + ";Password=" + txtPasswort.Text;
        }

        public string executeStatement(string sql)
        {
            string message = "init";
            SqlConnection conn = new SqlConnection(msSqlServerString);
            try
            {
                conn.Open();
                SqlCommand comm = new SqlCommand();
                comm.Connection = conn;
                comm.CommandText = sql;
                comm.ExecuteScalar();
                message = "ok";
            }
            catch (Exception ex)
            { 
                return ex.Message; 
            }
            finally
            {
                conn.Close();
            }

            return message;
        }

        public bool testDB()
        {
            SqlConnection conn = new SqlConnection(msSqlServerString);
            try
            {
                conn.Open();
            }
            catch (Exception ex)
            {
                return false;
            }
            finally
            {
                conn.Close();
            }

            return true;
        }

        private void WriteToDatabase()
        {
            // get your connection string
            string connString = msSqlServerString;
            // connect to SQL
            using (SqlConnection connection =  new SqlConnection(connString))
            {
                // make sure to enable triggers
                // more on triggers in next post

                SqlBulkCopy bulkCopy = new SqlBulkCopy
                (
                    connection,
                    SqlBulkCopyOptions.TableLock |
                    SqlBulkCopyOptions.FireTriggers |
                    SqlBulkCopyOptions.UseInternalTransaction,
                    null
                 );

                // set the destination table name
                bulkCopy.DestinationTableName = txtImportTable.Text;
                connection.Open();

                // write the data in the "dataTable"
                try
                {
                    bulkCopy.WriteToServer(dataTable);
                }
                catch (Exception e)
                {
                    MessageBox.Show("Es ist ein Fehler aufgetreten. Stellen Sie sicher dass der Timeout im SQL Server auf unendlich steht und AutoClose fr die Verbindung nicht aktiviert wurde. " + e.Message, "Fehler!");
                }
                connection.Close();
            }
            // reset
            this.dataTable.Clear();
            tabControl1.SelectedIndex = 3;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            WriteToDatabase();
        }

        private void btnZurueck_Click(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 3)
            {
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = true;
                tabControl1.SelectedIndex = 2;
            }
            else if (tabControl1.SelectedIndex == 2)
            {
                btnZurueck.Enabled = true;
                btnWeiter.Enabled = true;
                tabControl1.SelectedIndex = 1;
            }
            else if (tabControl1.SelectedIndex == 1)
            {
                btnZurueck.Enabled = false;
                btnWeiter.Enabled = true;
                tabControl1.SelectedIndex = 0;
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (testDB())
            {
                MessageBox.Show("Datenbank verbindung erfolgreich aufgebaut!", "ERFOLG");
            }
            else
            {
                MessageBox.Show("Keine Datenbank-Verbindung mglich. Testen sie bitte ihre Einstellungen, achten sie auf korrrekte Zugangsdaten!", "Joa mei desch mog i ned");
            }
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            button1_Click_1(null, null);
        }
    }
}